Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 631062 - media-gfx/splashutils-1.5.4.4-r7: undefined reference to `makedev'
Summary: media-gfx/splashutils-1.5.4.4-r7: undefined reference to `makedev'
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: No maintainer - Look at https://wiki.gentoo.org/wiki/Project:Proxy_Maintainers if you want to take care of it
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: glibc-sysmacros glibc-2.26-stable
  Show dependency tree
 
Reported: 2017-09-15 08:28 UTC by Massimo Burcheri
Modified: 2018-04-30 11:57 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
sysmacros patch (file_631062.txt,294 bytes, text/plain)
2017-10-10 23:05 UTC, Julio Aguilar Carmona
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Massimo Burcheri 2017-09-15 08:28:22 UTC
For a long time splashutils does not build anymore:

  CC      fbcondecor_helper-image.o
  CC      fbcondecor_helper-effects.o
  CC      fbcondecor_helper-ttf.o
daemon_cmd.c: In function ‘cmd_log’:
daemon_cmd.c:367:3: warning: implicit declaration of function ‘list_ringadd’ [-Wimplicit-function-declaration]
   list_ringadd(&theme->msglog, strndup(args[0], theme->log_cols));
   ^~~~~~~~~~~~
daemon.c: In function ‘thf_switch_ttymon’:
daemon.c:506:3: warning: ignoring return value of ‘read’, declared with attribute warn_unused_result [-Wunused-result]
   read(fd_tty[config.tty_s], &ret, 1);
   ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
daemon.c: In function ‘daemon_start’:
daemon.c:682:2: warning: ignoring return value of ‘chdir’, declared with attribute warn_unused_result [-Wunused-result]
  chdir("/");
  ^~~~~~~~~~
  CREATE  libfbsplash.pc
  CREATE  libfbsplashrender.pc
./.libs/libfbsplashrender.a(libfbsplashrender_la-common.o): In function `dev_create':
common.c:(.text+0xb7): undefined reference to `makedev'
collect2: error: ld returned 1 exit status
make[4]: *** [Makefile:993: fbsplashctl] Error 1
make[3]: *** [Makefile:1475: all-recursive] Error 1
make[2]: *** [Makefile:691: all] Error 2
make[1]: *** [Makefile:441: all-recursive] Error 1
make: *** [Makefile:372: all] Error 2

Reproducible: Always
Comment 1 Asaf Gery 2017-09-20 01:47:40 UTC
Could you please provide me with the USE flags you are using?
You can use equery (part of the package app-portage/gentoolkit) to query the use flags, like this:

equery u media-gfx/splashutils

I have no problems building splashutils on my own desktop machine.
Comment 2 Massimo Burcheri 2017-09-20 05:49:29 UTC
# equery uses media-gfx/splashutils
[ Legend : U - final flag setting for installation]
[        : I - package is installed with flag     ]
[ Colors : set, unset                             ]
 * Found these USE flags for media-gfx/splashutils-1.5.4.4-r7:
 U I
 - - fbcondecor : Support for the fbcondecor kernel patch. 
 + + gpm        : Add support for sys-libs/gpm (Console-based mouse driver)
 - - hardened   : Activate default security enhancements for toolchain (gcc, glibc, binutils)
 + + png        : Add support for libpng (PNG images)
 + + truetype   : Add support for FreeType and/or FreeType2 fonts
Comment 3 Michal Gawlik 2017-10-10 21:32:45 UTC
Same problem here. USE flags: fbcondecor png truetype -gpm -hardened

I did small research on the subject. The problem happens when running ~toolchain (just glibc, probably). The root cause is a "makedev" macro being used in src/common.c on line 59. It seems that newer glibc / gcc has its definition in another header file (sys/sysmacros.h instead of sys/types.h).

The easiest solution is to include <sys/sysmacros.h> before <sys/types.h> in common.c. The more complete solution is probably using autotools in similar manner like libvirt does: https://www.redhat.com/archives/libvir-list/2016-September/msg00458.html
Comment 4 Julio Aguilar Carmona 2017-10-10 23:05:26 UTC
Created attachment 498372 [details]
sysmacros patch
Comment 5 Viktor Yu. Kovalskii 2017-10-24 10:21:04 UTC
(In reply to Julio Aguilar Carmona from comment #4)
> Created attachment 498372 [details]
> sysmacros patch

Thanks a lot for the patch.
Right now I can build =media-gfx/splashutils-1.5.4.4-r7 with this patch and with USE="fbcondecor gpm png -hardened -truetype"

emerge --info 
Portage 2.3.12 (python 3.6.3-final-0, default/linux/amd64/13.0/desktop/plasma, gcc-6.4.0, glibc-2.25-r8, 4.9.58-gentoo x86_64)
=================================================================
System uname: Linux-4.9.58-gentoo-x86_64-AMD_A8-6600K_APU_with_Radeon-tm-_HD_Graphics-with-gentoo-2.4.1
KiB Mem:     7649944 total,   1139912 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Tue, 24 Oct 2017 05:15:01 +0000
Head commit of repository gentoo: 357ca93da5950e49461e62fc18c1fd67dc84e373
Timestamp of repository flying: Tue, 05 Sep 2017 03:55:13 +0000
Timestamp of repository oschtan: Wed, 05 Jul 2017 20:19:16 +0000
Head commit of repository kde: f854e86d5abaf6855867a5976626e4ae67f94147

Head commit of repository mozilla: 6852b24969cbc01f3d61f5b4760e6358592352f0

Head commit of repository science: f5fa3d050a6ae98a14266167c00241f7208c8452

sh bash 4.4_p12
ld GNU ld (Gentoo 2.29.1 p2) 2.29.1
ccache version 3.3.4 [enabled]
app-shells/bash:          4.4_p12::gentoo
dev-java/java-config:     2.2.0-r3::gentoo
dev-lang/perl:            5.26.1::gentoo
dev-lang/python:          2.7.14::gentoo, 3.6.3::gentoo
dev-util/ccache:          3.3.4-r1::gentoo
dev-util/cmake:           3.9.4::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.4.1-r2::gentoo
sys-apps/openrc:          0.33.1::gentoo
sys-apps/sandbox:         2.12::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.15.1-r1::gentoo
sys-devel/binutils:       2.29.1-r1::gentoo
sys-devel/gcc:            6.4.0::gentoo
sys-devel/gcc-config:     1.9.0::gentoo
sys-devel/libtool:        2.4.6-r4::gentoo
sys-devel/make:           4.2.1-r1::gentoo
sys-kernel/linux-headers: 4.9::gentoo (virtual/os-headers)
sys-libs/glibc:           2.25-r8::gentoo
Repositories:

gentoo
    location: /slag/gentoo-tree
    sync-type: rsync
    sync-uri: rsync://mirror.yandex.ru/gentoo-portage/
    priority: -1000
    sync-rsync-extra-opts: 

flying
    location: /slag/layman/flying
    masters: gentoo

oschtan
    location: /slag/layman/oschtan
    masters: gentoo

kde
    location: /slag/layman/kde
    sync-type: git
    sync-uri: https://anongit.gentoo.org/git/proj/kde.git
    masters: gentoo
    priority: 50

mozilla
    location: /slag/layman/mozilla
    sync-type: git
    sync-uri: https://anongit.gentoo.org/git/proj/mozilla.git
    masters: gentoo
    priority: 50

science
    location: /slag/layman/science
    sync-type: git
    sync-uri: https://anongit.gentoo.org/git/proj/sci.git
    masters: gentoo
    priority: 50

Installed sets: @toolchain
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA PUEL"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=bdver2 -mtune=bdver2 -O2 -pipe -mmmx -mno-3dnow -msse -msse2 -msse3 -mssse3 -msse4a -mcx16 -msahf -mno-movbe -maes -mno-sha -mpclmul -mpopcnt -mabm -mlwp -mfma -mfma4 -mxop -mbmi -mno-bmi2 -mtbm -mavx -mno-avx2 -msse4.2 -msse4.1 -mlzcnt -mno-rtm -mno-hle -mno-rdrnd -mf16c -mno-fsgsbase -mno-rdseed -mprfchw -mno-adx -mfxsr -mxsave -mno-xsaveopt -mno-avx512f -mno-avx512er -mno-avx512cd -mno-avx512pf -mno-prefetchwt1 -fstack-protector-strong --param l1-cache-size=16 --param l1-cache-line-size=64 --param l2-cache-size=2048"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/splash /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=bdver2 -mtune=bdver2 -O2 -pipe -mmmx -mno-3dnow -msse -msse2 -msse3 -mssse3 -msse4a -mcx16 -msahf -mno-movbe -maes -mno-sha -mpclmul -mpopcnt -mabm -mlwp -mfma -mfma4 -mxop -mbmi -mno-bmi2 -mtbm -mavx -mno-avx2 -msse4.2 -msse4.1 -mlzcnt -mno-rtm -mno-hle -mno-rdrnd -mf16c -mno-fsgsbase -mno-rdseed -mprfchw -mno-adx -mfxsr -mxsave -mno-xsaveopt -mno-avx512f -mno-avx512er -mno-avx512cd -mno-avx512pf -mno-prefetchwt1 -fstack-protector-strong --param l1-cache-size=16 --param l1-cache-line-size=64 --param l2-cache-size=2048"
DISTDIR="/slag/distfiles"
EMERGE_DEFAULT_OPTS="--autounmask=n --with-bdeps=y --quiet-build"
FCFLAGS="-march=bdver2 -mtune=bdver2 -O2 -pipe -mmmx -mno-3dnow -msse -msse2 -msse3 -mssse3 -msse4a -mcx16 -msahf -mno-movbe -maes -mno-sha -mpclmul -mpopcnt -mabm -mlwp -mfma -mfma4 -mxop -mbmi -mno-bmi2 -mtbm -mavx -mno-avx2 -msse4.2 -msse4.1 -mlzcnt -mno-rtm -mno-hle -mno-rdrnd -mf16c -mno-fsgsbase -mno-rdseed -mprfchw -mno-adx -mfxsr -mxsave -mno-xsaveopt -mno-avx512f -mno-avx512er -mno-avx512cd -mno-avx512pf -mno-prefetchwt1 -fstack-protector-strong --param l1-cache-size=16 --param l1-cache-line-size=64 --param l2-cache-size=2048"
FEATURES="assume-digests binpkg-logs buildpkg ccache cgroup config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync multilib-strict news parallel-fetch preserve-libs protect-owned sandbox sfperms split-log strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-march=bdver2 -mtune=bdver2 -O2 -pipe -mmmx -mno-3dnow -msse -msse2 -msse3 -mssse3 -msse4a -mcx16 -msahf -mno-movbe -maes -mno-sha -mpclmul -mpopcnt -mabm -mlwp -mfma -mfma4 -mxop -mbmi -mno-bmi2 -mtbm -mavx -mno-avx2 -msse4.2 -msse4.1 -mlzcnt -mno-rtm -mno-hle -mno-rdrnd -mf16c -mno-fsgsbase -mno-rdseed -mprfchw -mno-adx -mfxsr -mxsave -mno-xsaveopt -mno-avx512f -mno-avx512er -mno-avx512cd -mno-avx512pf -mno-prefetchwt1 -fstack-protector-strong --param l1-cache-size=16 --param l1-cache-line-size=64 --param l2-cache-size=2048"
GENTOO_MIRRORS="https://mirror.yandex.ru/gentoo-distfiles/ http://trumpetti.atm.tut.fi/gentoo"
LANG="ru_RU.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j5"
PKGDIR="/slag/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/slag"
USE="X a52 aac acl acpi activities alsa amd64 berkdb branding bs2b bzip2 cairo caps cdr cli consolekit cracklib cups custom-cflags custom-optimization cxx dbus declarative djvu dri dts dvd dvdr emboss enca encode exceptions exif ffmpeg firefox flac fontconfig fortran gif gimp glamor gmp gpm harfbuzz iconv icu idn jbig jit jpeg jpeg2k kde kwallet latex lcms libass libnotify libsamplerate lm_sensors lz4 lzma lzo mng modules mp3 mp4 mpeg multilib ncurses nls nptl nsplugin ogg opengl openmp pam pango pcre pdf phonon plasma png policykit postscript ppds pulseaudio qml qt3support qt5 rar readline samba sdl seccomp session sndfile spell sqlite ssl startup-notification subversion svg taglib tcpd theora threads tiff truetype udev udisks unicode upower usb utils vdpau vorbis wavpack webengine webp widgets wxwidgets x264 xattr xcb xcomposite xml xv xvid zip zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx f16c fma3 fma4 mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 sse4a ssse3 xop" CURL_SSL="gnutls" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="pc" INPUT_DEVICES="evdev" KERNEL="linux" L10N="ru" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="nlpsolver" LINGUAS="ru" LLVM_TARGETS="AMDGPU" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6" POSTGRES_TARGETS="postgres9_5" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python3_6 python2_7" RUBY_TARGETS="ruby24" SANE_BACKENDS="abaton agfafocus apple artec artec_eplus48u as6e avision bh canon canon630u canon_dr canon_pp cardscan coolscan coolscan2 coolscan3 dc210 dc240 dc25 dell1600n_net dmc epjitsu epson epson2 fujitsu genesys gt68xx hp hp3500 hp3900 hp4200 hp5400 hp5590 hpljm1005 hpsj5s hs2p ibm kodak kvs1025 leo lexmark ma1509 matsushita microtek microtek2 mustek mustek_pp mustek_usb nec net niash p5 pie pixma plustek plustek_pp qcam ricoh rts8891 s9036 sceptre sharp sm3600 sm3840 snapscan sp15c st400 stv680 tamarack teco1 teco2 teco3 test u12 umax umax1220u umax_pp xerox_mfp kvs20xx magicolor pnm kodakaio kvs40xx mustek_usb2" USERLAND="GNU" VIDEO_CARDS="radeon r600" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 6 Viktor Yu. Kovalskii 2017-10-25 02:55:21 UTC
I think this bug should block https://bugs.gentoo.org/575232
Comment 7 Conrad Kostecki 2017-12-03 18:02:04 UTC
(In reply to Julio Aguilar Carmona from comment #4)
> Created attachment 498372 [details]
> sysmacros patch

Thanks, did work for me.
Comment 8 Larry the Git Cow gentoo-dev 2018-04-30 11:57:05 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ae30efc75cf4559bdd3b2a1c880862a85e2f96e3

commit ae30efc75cf4559bdd3b2a1c880862a85e2f96e3
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2018-04-30 11:53:36 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2018-04-30 11:56:44 +0000

    media-gfx/splashutils: Stable for amd64 and x86, bug 631062
    
    It may have bugs, but it for sure doesnt have *regressions*...
    
    Closes: https://bugs.gentoo.org/631062
    Package-Manager: Portage-2.3.31, Repoman-2.3.9

 media-gfx/splashutils/splashutils-1.5.4.4-r8.ebuild | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)